#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    int a[n+1];
    scanf("%d",&n);
   int mop[n+1]={0};
    for(int i=1;i<=n;i++)
    {
       scanf("%d",&a[i]);
       if(i>1&&a[i]<a[i-1])mop[i]=mop[i-1]+1;
       else mop[i]=mop[i-1];
    }
    int q;
    int l;
    int r;
    scanf("%d",&q);
    for(int i=1;i<=q;i++)
    {
        scanf("%d",&l);
        scanf("%d",&r);
        if(mop[r]-mop[l]>=2)
        {
            printf("NE\n");
        }
        else if (mop[r]-mop[l]==0)
        {
            printf("DA\n");
        }
        else
        {
        bool moze =true;
        for(int j=l+1;j<=r;j++)
        {
            if(a[j]<a[j-1])
            {
                if(!(a[j]>=a[j-2])&&!(a[j+1]>=a[j-1])&&!(j==l+1)&&!(j==r))
                {
                    moze=false;
                    break;
                }
            }
        }
        if(moze)printf("DA\n");
        else printf("NE\n");
        }
    }
    return 0;
}